package it.amattioli.encapsulate.dates.specifications;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.specifications.Assembler;
import it.amattioli.dominate.specifications.hibernate.CriteriaAssembler;

public class CriteriaDateSpecification<T extends Entity<?>> extends DateSpecification<T> {

	public CriteriaDateSpecification(String propertyName) {
		super(propertyName);
	}

	public CriteriaDateSpecification(String propertyName, DateSpecification<T> chained) {
		super(propertyName, chained);
	}

	@Override
	public void itselfAssembleQuery(Assembler assembler) {
		addCriteria(((CriteriaAssembler) assembler).assembledCriteria());
	}

	@Override
	public boolean itselfSupportsAssembler(Assembler assembler) {
		return assembler instanceof CriteriaAssembler;
	}
	
	private void addCriteria(Criteria crit) {
        if (wasSet()) {
        	if (getValue().isLowBounded()) {
        		crit.add(Restrictions.ge(getPropertyName(), getValue().getLow()));
        	}
        	if (getValue().isHighBounded()) {
        		crit.add(Restrictions.lt(getPropertyName(), getValue().getHigh()));
        	}
        }
    }

}
